# Sign-Quote

### Receiving Sign Quote request

After our server has validated the firm quote, we will request you to sign the quote with the following message:

```
{
  "messageType": "signQuote",
  "message": {
    "chainId": number,
    "quoteId": number,
    // <OPTIONAL> In wei, the amount that the market maker is allowed to borrow from native's credit pool
    "availableBorrowBalance": string,
    "isBorrowing": boolean, <OPTIONAL> boolean value to indicate whether you want to use native's credit pool
    "quoteData": {
      // It is leveraged to mitigate quote replay.
      "id": number,
      "signer": string,
      "buyer": string,
      "seller": string,
      "buyerToken": string,
      "sellerToken": string,
      "buyerTokenAmount":  string,
      "sellerTokenAmount": string,
      "deadlineTimestamp": string,
      "caller": string,
      "quoteId": string,
    }
  }
}
```

### Sending Sign Quote response

You need to sign the quote based on the EIP712 specification with our order format. Refer to this guide for an example of signing transactions. After signing, send the response back to Native in the following format:

```
{
  "messageType": "signature",
  "message": {
    "quoteId": string,  // This is the quote id previously sent.
    "signature": string  // 0x-prefix signature (65 bytes)
  }
}
```

{% hint style="info" %}
**Note**: The Native server will generally wait **up to 350 milliseconds** for a quote to be signed before the quote is flagged as invalid. Too many signature failures can result in an order pause for the Market Maker, as it affects the user experience for those trading through Native.
{% endhint %}

{% hint style="success" %}
Congratulations! You have successfully integrated with Native and are now a Market Maker.
{% endhint %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.native.org/native-dev/build-with-native/market-makers/api-guide/websocket-integration/sign-quote.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
